<?php
/**
 * Class Funcs
 * Date: 12 Feb 2016
 * Ver.: 2.1
 */

?>
<style>
.err,.error{color:red}
.info{color:blue}
.ok{color:green}
.b{font-weight: bold;}
</style>
<?php

    // Get scan path
    $scan_path = dirname(__FILE__);
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') 
    {	// Windows
    	define('DIRSEP', '\\');
        $scan_path = $scan_path.DIRSEP;
    }
    else {
    	// Unix
    	define('DIRSEP', '/');
        //$scan_path = DIRSEP.$scan_path;
        $scan_path = $scan_path.DIRSEP;
    }
    $scan_path = str_replace( DIRSEP.DIRSEP, DIRSEP, $scan_path );
    
    
    
    

class SiteGuarding_files
{
    public static  $debug = true;
    
    var $scan_path = '';
    
    var $filter_ext = false;        // true - .php, js and etc
    var $filter_ext_extra = array();        // 'css', 'inc' and etc
	var $filter_by_name = '';		// e.g. error_log
    
    var $remove_slash = true;        
    var $short_path = true; 

	var $show_output = false; 	
    
	var $exclude_folders = array();		// array('/folder_1/', '/folder_2/')
    var $exclude_folders_real = array();
    var $filter_filesize = array();
    
 

    public function LoadFileList($filename)
    {
        $files = file($filename, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
        
        return $files;
    }
    
    
	public function GetFileList()
	{
	    // Start scanning process
	    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') define(DIRSEP, '\\');
		else define(DIRSEP, '/');
        
        $scan_path = $this->scan_path;

        

		// Analyze of exclude folders
		if (file_exists($this->scan_path.'exclude_folders.php'))
		{
			$error_msg = '=> Exclude folders file loaded'."<br>";
			if (self::$debug) echo $error_msg;
			
			require_once($this->scan_path.'exclude_folders.php');	
		}
		
		
	
		$tmp_result = set_time_limit ( 7200 );
		


        
        $files_list = array();


        
        $exclude_folders_real = array();
		if (count($exclude_folders))
		{
			foreach ($exclude_folders as $k => $ex_folder)
			{
				$ex_folder = $scan_path.trim($ex_folder);
				$exclude_folders_real[$k] = trim(str_replace(DIRSEP.DIRSEP, DIRSEP, $ex_folder));	
			}
		}
		else $exclude_folders_real = array(); 
		
		if (count($this->exclude_folders))
		{
			foreach($this->exclude_folders as $ex_folder)
			{
				$ex_folder = $scan_path.trim($ex_folder);
				$exclude_folders_real[] = trim(str_replace(DIRSEP.DIRSEP, DIRSEP, $ex_folder));
			}
		}
		
        $this->exclude_folders_real = $exclude_folders_real; 
        
        
		$error_msg = 'Excluded Folders: '.count($exclude_folders_real)."<br>";
		if (self::$debug) echo $error_msg;
		
		$error_msg = print_r($exclude_folders_real, true)."<br>";
		if (self::$debug && count($exclude_folders_real) > 0) echo $error_msg; 
        
        $dirList = array();
        $dirList[] = $scan_path;
        
        
 
                
        // Scan all dirs
        while (true) 
        {
            $dirList = array_merge(self::ScanFolder(array_shift($dirList), $files_list), $dirList);
            if (count($dirList) < 1) break;
        }
        
        return $files_list;
        
    }
    
    
    
    
    
    function ScanFolder($path, &$files_list)
    {
        $dirList = array();
    
        if ($currentDir = opendir($path)) 
        {
            while ($file = readdir($currentDir)) 
            {
                if ( $file === '.' || $file === '..' || is_link($path) ) continue;
                $file = $path . '/' . $file;
    
                
                if (is_dir($file)) 
                {
                    $folder = $file.DIRSEP;
                    $folder = str_replace(DIRSEP.DIRSEP, DIRSEP, $folder);
                    
                    // Exclude folders
                    if (count($this->exclude_folders_real))
                    {
                 		if (in_array($folder, $this->exclude_folders_real)) 
        				{
        				    //if (self::$debug) self::DebugLog('--- '.$folder);
                            continue;
        				}
        				//else if (self::$debug) self::DebugLog('+++ '.$folder);
                    }
                    $dirList[] = $file;
                    
                }
                else {
                    
                    $filesize = filesize($file);
                    
                    if ($this->short_path)
                    {
                        $file = str_replace($this->scan_path, "", $file);
        				if ($this->remove_slash) if ($file[0] == "\\" || $file[0] == "/") $file[0] = "";
        				$file = trim($file);
                    }
					


                    
                    // Check extension
                    if ($this->filter_ext)
                    {
                        $ext = strtolower(pathinfo($file, PATHINFO_EXTENSION));
						if (strpos($file, '.php.') || strpos($file, '.phtml.') || strpos($file, '.php3.') || strpos($file, '.php4.') || strpos($file, '.php5.'))
						{
							$files_list[] = $file;
							
							if ($this->show_output)
							{	
								echo $file."<br>";
								ob_flush();
								flush();
							}
						}
						else {
							switch ($ext)
							{
								case 'inc':
								case 'php':
								case 'php4':
								case 'php5':
								case 'phtml':
								case 'js':
								case 'html':
								case 'htm':
								case 'cgi':
								case 'pl':
								case 'so':
								case 'sh':
								case 'htaccess':
									$files_list[] = $file;
								
									if ($this->show_output)
									{	
										echo $file."<br>";
										ob_flush();
										flush();
									}
									break;
							}
						}
                    }
                    else {
                        if (count($this->filter_ext_extra))
                        {
                            $ext = strtolower(pathinfo($file, PATHINFO_EXTENSION));
                            foreach ($this->filter_ext_extra as $value)
                            {
                                if ($ext == $value) $files_list[] = $file;
                            }
                        }
                        else if (count($this->filter_filesize))
                            {
                                foreach ($this->filter_filesize as $value)
                                {
                                    if ($filesize == $value) $files_list[] = $file;
                                }
                            }
                            else if ($this->filter_by_name != '')
								{
									$this_filename = strtolower(pathinfo($file, PATHINFO_BASENAME));
									if ($this_filename == $this->filter_by_name)
									{
										$files_list[] = $file;
									}
								}
								else $files_list[] = $file;
                    }
                    
                }
    
            }
            closedir($currentDir);
        }
    
        return $dirList;
    }


}

?>