<?php
/*
 * Example of plugin file
 * RunPlugins() - must be to execute plugins
 */

function RunPlugins()
{
	// Execute what you need
	UpdateFirewallKey();
    
    UpdateFirewallInjection();
}

function UpdateFirewallKey()
{
	$file = dirname(__FILE__).DIRSEP."firewall".DIRSEP."firewall.php";
	if (file_exists($file))
	{
		$file = dirname(__FILE__).DIRSEP."firewall".DIRSEP."firewall.key.txt";
		$fp = fopen($file, 'w');
		fwrite($fp, 'NO_KEY');
		fclose($fp);
	}
}

function UpdateFirewallInjection()
{
    $currentDir = SCAN_PATH.DIRSEP;
    
    if (file_exists($currentDir.'webanalyze/firewall/firewall.php'))
    {
        $integration_code = '<?php /* Siteguarding Block 44B280167949-START */include_once("'.$currentDir.'webanalyze/firewall/firewall.php");/* Siteguarding Block 44B280167949-END */?>';
        
        $list_of_files = array(
            'index.php',
            'wp-config.php',
            'wp-login.php',
            
            'configuration.php'
        ); 
        
        
        // Update firewall config
        $filename = $currentDir.'webanalyze/firewall/firewall.config.php';
        if (file_exists($filename))
        {
            $handle = fopen($filename, "r");
            $contents = fread($handle, filesize($filename));
            fclose($handle);
            
            $contents = str_replace("{REPLACE_WITH_SCAN_PATH}", $currentDir, $contents);
            
            $handle = fopen($filename, 'w');
            $status = fwrite($handle, $contents);
            fclose($handle);
        }
        
        
        foreach ($list_of_files as $file)
        {
            if (file_exists($currentDir.$file))
            {
                // Insert code
                $filename = $currentDir.$file;
                $handle = fopen($filename, "r");
                $contents = fread($handle, filesize($filename));
                fclose($handle);
                
               
                if (strpos($contents, $integration_code) !== false && $flag_remove == 0)
                {
                    // Skip double code injection
                    continue;
                }
                
                $handle = fopen($filename, 'w');
                if ($handle === false) 
                {
                    // 2nd try , change file permssion to 644
                    $status = chmod($filename, 0644);
                    
                    $handle = fopen($filename, 'w');
                    if ($handle === false) continue;
                }
                
                
                $contents = $integration_code.$contents;
                
                $status = fwrite($handle, $contents);
                fclose($handle);
                
            }

        }
      
        
    }
    

    
    
        
}


?>