<?php
/**
 * Collect all request module
 * Copyright by SiteGuarding.com
 * Date: 22 feb 2016
 * ver.: 2.6
 */
define( 'SITEGUARDING_DEBUG', false);
define( 'SITEGUARDING_DEBUG_IP', '1.2.3.4');

//if (isset($_REQUEST['task']) && $_REQUEST['task'] == 'cron' && isset($_REQUEST['access_key']) && isset($_REQUEST['anticache'])) return;

if( ! ini_get('date.timezone') )
{
    date_default_timezone_set('GMT');
}


if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') $DIRSEP = '\\';
else $DIRSEP = '/';

$file_firewall_class = dirname(__FILE__).$DIRSEP.'firewall.class.php';
$file_firewall_config = dirname(__FILE__).$DIRSEP.'firewall.config.php';
$file_firewall_rules = dirname(__FILE__).$DIRSEP.'rules.txt';

/**
 * Debug some values
 */
if (SITEGUARDING_DEBUG === true && $_SERVER["REMOTE_ADDR"] == SITEGUARDING_DEBUG_IP)
{
    echo 'Class '.$file_firewall_class."<br>";
    echo 'Config '.$file_firewall_config."<br>";
    echo 'Rules '.$file_firewall_rules."<br>";
    echo 'Request: <br><pre>'.print_r($_REQUEST, true).'</pre>'."<br><br>";
    echo 'Server: <br><pre>'.print_r($_SERVER, true).'</pre>'."<br><br>";
}


if (file_exists($file_firewall_class)) include_once($file_firewall_class);
else die('File is not loaded: '.$file_firewall_class);


if (file_exists($file_firewall_config)) include_once($file_firewall_config);
else die('File is not loaded: '.$file_firewall_config);

if (!file_exists($file_firewall_rules)) die('File is not loaded: rules.txt');

if (SITEGUARDING_FIREWALL_STATUS === false) return;     // exit if firewall is disabled


// Some init constants
if (!defined('SITEGUARDING_LOG_FILE_MAX_SIZE')) define( 'SITEGUARDING_LOG_FILE_MAX_SIZE', 5);	// log file in Mb
if (!defined('SITEGUARDING_BLOCK_BASE64_REQUESTS')) define( 'SITEGUARDING_BLOCK_BASE64_REQUESTS', false);	// block any base64 requests


$firewall = new SiteGuarding_Firewall();

if (!$firewall->CheckLicKey()) 
{
    if (SITEGUARDING_DEBUG === true && $_SERVER["REMOTE_ADDR"] == SITEGUARDING_DEBUG_IP)
    {
        echo 'Lic Key is not valid.';
    }
    return;
}

$firewall->this_session_rule = SITEGUARDING_DEFAULT_ACTION;
$firewall->email_for_alerts = SITEGUARDING_EMAIL_FOR_ALERTS;
$firewall->save_empty_requests = SITEGUARDING_SAVE_EMPTY_REQUESTS;
$firewall->single_log_file = SITEGUARDING_SINGLE_LOG_FILE;
$firewall->scan_path = SITEGUARDING_SCAN_PATH;
$firewall->dirsep = SITEGUARDING_DIRSEP;
$firewall->float_file_folder = SITEGUARDING_FLOAT_FILE_FOLDER;
$firewall->log_file_max_size = SITEGUARDING_LOG_FILE_MAX_SIZE;


// Check php.ini in all the folders
//$firewall->InstallPHPini();



// Load and parse the rules
if (!$firewall->LoadRules()) die('Rules are not loaded');



// Log the request
// *moved to the end* $firewall->LogRequest();

// Checking this request based on the rules
if ($firewall->CheckIP_in_Allowed($_SERVER["REMOTE_ADDR"])) {$firewall->LogRequest(); return;}

if ($firewall->CheckIP_in_Alert($_SERVER["REMOTE_ADDR"]))
{   // Send alert to admin
    $subject = 'Access from IP '.$_SERVER["REMOTE_ADDR"];
    $message = date("Y-m-d H:i:s")."\n".
    	"IP:".$_SERVER["REMOTE_ADDR"]."\n".
    	"Link:"."http://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]"."\n".
    	"File:".$_SERVER[SCRIPT_FILENAME]."\n".
    	print_r($_REQUEST, true)."\n\n";
    $firewall->SendEmail($subject, $message);
}

if ($firewall->CheckIP_in_Blocked($_SERVER["REMOTE_ADDR"]))
{
    $firewall->Block_This_Session('Not allowed IP '.$_SERVER["REMOTE_ADDR"]);   // the process will die
    exit;
}

// Global RULES
$tmp_session_rule = $firewall->Session_Apply_Rules($_SERVER['SCRIPT_FILENAME']);
if ($tmp_session_rule != '') $firewall->this_session_rule = $tmp_session_rule;

if ($firewall->this_session_rule == 'block')
{
    $firewall->Block_This_Session('Rules for the file');   // the process will die
    exit;
}


// BLOCK_RULES_IP
$tmp_session_rule = $firewall->Session_Apply_BLOCK_RULES_IP($_SERVER['SCRIPT_FILENAME'], $_SERVER["REMOTE_ADDR"]);
if ($tmp_session_rule != '') $firewall->this_session_rule = $tmp_session_rule;

if ($firewall->this_session_rule == 'block')
{
    $firewall->Block_This_Session('Rules for the file & IP');   // the process will die
    exit;
}


// Check Requests
$tmp_session_rule = $firewall->Session_Check_Requests($_REQUEST);
if ($tmp_session_rule != '') $firewall->this_session_rule = $tmp_session_rule;

if ($firewall->this_session_rule == 'block')
{
    $firewall->Block_This_Session('Request rule => '.$firewall->this_session_reason_to_block, true);   // the process will die
    exit;
}


// Log the request (the request passed all the rules)
$firewall->LogRequest();


if (SITEGUARDING_DEBUG === true && $_SERVER["REMOTE_ADDR"] == SITEGUARDING_DEBUG_IP)
{
    echo 'Finished'."<br>";
}


?>