<?php
// Manual installation of security monitor

/**
 * Website: http://www.siteguarding.com/
 * Email: support@siteguarding.com
 *
 * @author John Coggins
 * @version 2.2 (open)
 * @package SiteGuarding Installer
 */


 
define('MAIN_SERVER_URL', 'https://www.siteguarding.com/_get_file.php?file=');
define('MAIN_SERVER_IP_1', '185.72.156.128');
define('MAIN_SERVER_IP_2', '185.72.156.129');
define ('SETUP_CONNECT_TIMEOUT', 30);

error_reporting( 0 );

$script_path = dirname(__FILE__);
$scan_path = str_replace("webanalyze", "", $script_path);   // With / in the end

$result = array();
$result['status'] = 'ok';

$action = $_GET['action'];

switch ($action)
{
    default:
        // Check before installion
        // Check if dir is writable
        if (!is_writable($script_path))
        {
            $result['status'] = 'error'; 
            $result['errors'][] = 'COM_SAPP_ERROR_DIR_IS_NOT_WRITABLE';
        }
        
        break;
        
        
        
    case 'install':
		#DebugLog('Installation start', true);
        // Download and create the files
        $website_id = intval($_GET['website_id']);
        $website_key = trim($_GET['website_key']);
        
        // Create index.html
        CreateFile($script_path, 'index.html', '<html><body bgcolor="#FFFFFF"></body></html>');
        
        // Create php.ini
        $lines = Read_File($script_path, 'php.ini');
        CreateFile($script_path, 'php.ini', $lines.'max_execution_time = 600');
        
        // Create config.php
        $file_content = '<?php'."\n".
            'define("ENABLE_COMMON_FILTER", 1);'."\n".
            '$CONFIG_EXTRA_FILTER = array();'."\n".
            '$CONFIG_EXCLUDE_FOLDERS = array("/webanalyze/firewall/logs/");'."\n".
            'define("WEBSITE_ID", "'.$website_id.'");'."\n".
            'define("WEBSITE_KEY", "'.$website_key.'");'."\n".
            '?>'."\n";
        CreateFile($script_path, 'config.php', $file_content);
        
        // Create .htaccess
        /*$file_content = '# ALLOW ONLY MONITORING SERVER'."\n".
            '<Limit GET POST>'."\n".
            'order deny,allow'."\n".
            'deny from all'."\n".
            'allow from '.MAIN_SERVER_IP_1."\n".
            'allow from '.MAIN_SERVER_IP_2."\n".
            '</Limit>';
        CreateFile($script_path, '.htaccess', $file_content);*/
        
        // Create collectdata.php
        $file_content = CreateRemote_file_contents(MAIN_SERVER_URL.'collectdata.open&time='.time(), $script_path.'/collectdata.php');
		
        // Create collectdata.php
        $file_content = CreateRemote_file_contents(MAIN_SERVER_URL.'tunnel&time='.time(), $script_path.'/tunnel.php');
        
        
        // Update firewall config
        $filename = $script_path.'/firewall/firewall.config.php';
        if (file_exists($filename))
        {
            $handle = fopen($filename, "r");
            $contents = fread($handle, filesize($filename));
            fclose($handle);
            
            $contents = str_replace("{REPLACE_WITH_SCAN_PATH}", $scan_path, $contents);
            
            $handle = fopen($filename, 'w');
            fwrite($handle, $contents);
            fclose($handle);
        }
        
        
        // Inject firewall commant to WordPress config file
		$file_list_array = array(
			'wp-config.php',
			'configuration.php',
			'cron.php',
			'index.php'
		);
		
		foreach ($file_list_array as $filename)
        {
            $filename = $scan_path.$filename;
            if (file_exists($filename))
            {
                $handle = fopen($filename, "r");
                $contents = fread($handle, filesize($filename));
                fclose($handle);
                
                $integration_code = '<?php /* Siteguarding Block 44B280167949-START */include_once("'.$scan_path.'webanalyze/firewall/firewall.php");/* Siteguarding Block 44B280167949-END */?>';
                $contents = $integration_code.$contents;
                
                $handle = fopen($filename, 'w');
                fwrite($handle, $contents);
                fclose($handle);
            }
        }

        
        
        // Register ANY antivirus version
		// Send data
	    $link = 'http://www.siteguarding.com/ext/antivirus/index.php?action=register&type=json&data=';
		
		#DebugLog('Link: '.$link);
        
        $domain = GetWebsiteURL();
		#DebugLog('Domain: '.$domain);
        $email = 'test@siteguarding.com';
        $access_key = md5(time().$domain.rand(1, 20000).$email);
	    
	    $data = array(
			'domain' => $domain,
			'email' => $email,
			'access_key' => $access_key,
			'errors' => '',
			'call_back' => 1
		);
	    $link .= base64_encode(json_encode($data));
		#DebugLog('Link: '.$link);
        
        $a = trim(GetRemote_file_contents($link));
		
		#DebugLog('Result: '.$a);
        

        
        
        
        // Delete this setup.php
        unlink(__FILE__);
        break;
}

echo json_encode($result);
exit;




/**
 * Functions
 */

function GetRemote_file_contents($url, $parse = false)
{
    if (extension_loaded('curl')) 
    {
        $ch = curl_init();
        
        curl_setopt($ch, CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
        curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
        curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10); // 10 sec
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 10000); // 10 sec
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        
        $output = trim(curl_exec($ch));
        curl_close($ch);
        
        if ($output === false)  return false;
        
        if ($parse === true) $output = (array)json_decode($output, true);
        
        return $output;
    }
    else return false;
}

function GetWebsiteURL()
{
   $this_filename = '/webanalyze/'.pathinfo(__FILE__, PATHINFO_BASENAME);
   return 'http://'.$_SERVER['HTTP_HOST'].str_replace($this_filename, "", $_SERVER['SCRIPT_NAME']);
}

function Read_File($path, $file)
{
    $contents = '';
    
    $filename = $path.'/'.$file;
    if (file_exists($filename))
    {
        $fp = fopen($filename, "r");
        $contents = fread($fp, filesize($filename));
        fclose($fp); 
        
        $contents .= "\n\n";       
    }
    
    return $contents;
}

function CreateFile($path, $file, $content)
{
    $fp = fopen($path.'/'.$file, 'w');
    fwrite($fp, $content);
    fclose($fp);
}

function CreateRemote_file_contents($url, $dst)
{
    if (extension_loaded('curl')) 
    {
        $dst = fopen($dst, 'w');
        
        $ch = curl_init();
        
        curl_setopt($ch, CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
        curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
        curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
        curl_setopt($ch, CURLOPT_FILE, $dst);
        curl_setopt($ch, CURLOPT_FAILONERROR, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10); // 10 sec
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 10000); // 10 sec
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        
        $a = curl_exec($ch);
        if ($a === false)  return false;
        
        $info = curl_getinfo($ch);
        
        curl_close($ch);
        fflush($dst);
        fclose($dst);
        
        return $info['size_download'];
    }
    else return false;
        
}

function DebugLog($txt, $clean_log_file = false)
{
	if ($clean_log_file) $fp = fopen(dirname(__FILE__).'/setup.log', 'w');
	else $fp = fopen(dirname(__FILE__).'/setup.log', 'a');
	$a = date("Y-m-d H:i:s")." ".$txt."\n";
	fwrite($fp, $a);
	fclose($fp);
}
?>